exception chec;;

let reconnat automate chane =
  let tat_courant = ref automate in 
  try
    for i = 0 to string_length chane - 1 do
    match !tat_courant.dtransitions.(int_of_char(nth_char chane i))
    with Rejet  -> raise chec
       | Vers e -> tat_courant := e
    done;
    !tat_courant.dterminal
  with chec -> false;;
#open "auto";;

type ensemble_d'tats =
  { contenu  : ensent__t;
    lments : auto__tat list };;
let vide = { contenu = ensent__vide; lments = [] };;
let est_vide ens =
  match ens.lments with [] -> true | _ -> false;;
let appartient tat ens =
  ensent__appartient tat.numro ens.contenu;;
let ajoute tat ens =
  { contenu  = ensent__ajoute tat.numro ens.contenu;
    lments = tat :: ens.lments };;
let rec ajoute_fermeture tat ferm =
  if appartient tat ferm then ferm else
    list_it ajoute_fermeture
            tat.epsilon_transitions (ajoute tat ferm);;

let fermeture tat = ajoute_fermeture tat vide;;

let fermeture_ens ens = list_it ajoute_fermeture ens.lments vide;;
let dplacements liste_tats =
  let t = make_vect 256 vide in
  do_list
    (function tat ->
      do_list
        (function (car, dest) ->
          let i = int_of_char car in t.(i) <- ajoute dest t.(i))
      tat.transitions)
    liste_tats;
  t;;
let dterminise tat_initial =
  let tats_connus = hashtbl__new 51
  and _remplir = stack__new () in
  let traduire ens =
    try hashtbl__find tats_connus ens.contenu
    with Not_found ->
      let nouvel_tat =
        { dterminal = exists (function n -> n.terminal) ens.lments;
          dtransitions = make_vect 256 Rejet } in
      hashtbl__add tats_connus ens.contenu nouvel_tat;
      stack__push (ens.lments, nouvel_tat) _remplir;
      nouvel_tat in
  let nouvel_tat_initial =
    traduire (fermeture tat_initial) in
  begin try
    while true do
      let (liste, nouvel_tat) = stack__pop _remplir in
      let dpl = dplacements liste in
      for i = 0 to 255 do
        if not est_vide dpl.(i) then
          nouvel_tat.dtransitions.(i) <-
            Vers(traduire (fermeture_ens dpl.(i)))
      done
    done
  with stack__Empty -> ()
  end;
  nouvel_tat_initial;;
