/*------------------------------------------------------*/
/* Notes:                                               */
/*                                                      */
/* -Data initialization is used by "b_glbl.c".          */
/*                                                      */
/* -Data structure e_mtyp is defined in "o_type.h".     */
/*                                                      */
/* -All msgid numbers (1.component) must be different.  */
/*  1 <= msgid < E_TRES                                 */
/*                                                      */
/* -Data initializations may be ordered arbitrarily.    */
/*                                                      */
/* -There must be a final comma.                        */
/*                                                      */
/* -"\" is only allowed in conjunction with "r" or "n". */
/*                                                      */
/* - "\r" advances to the next line if '\r' is not the  */
/*   first character and displays e_hlen Blanks if      */
/*   '\r' is not the first or last character.           */
/*   If '\r' is the first character, the current line   */
/*   is continued and no indentation is done.           */
/*                                                      */
/* - "\n" advances to the next line and displays        */
/*   e_head if '\n' is not the last character.          */
/*                                                      */
/*      Date            : 1991-01-23                    */
/*      1991-01-23 : new 62-63 / e_mtyp changed         */
/*      1990-12-03 : new 59-61                          */
/*      1990-10-16 : new 58                             */
/*      1990-10-15 : new 55-57                          */
/*      1990-10-09 : new 54                             */
/*      1990-09-10 : new 51-53                          */
/*      1990-09-06 : new 47-50                          */
/*      1990-08-09 : new 46                             */
/*      1990-08-08 : new 44-45                          */
/*      1990-07-18 : new 43                             */
/*      1990-07-09 : new 38-42                          */
/*------------------------------------------------------*/

/* e_xdbz                                               */
{    1,  "Division by zero\n" },
/* r_divn, r_divu, r_divd                               */
{    2,  "\r0/0\n" },
/* e_xio1, e_xio3, e_xio4                               */
{    3,  "Invalid operation : " },
/* divtrap.h                                            */
{    4,  "\rinfinity/infinity\n" },
/* divtrap.h,addbody.h,subbody.h,mulbody.h,d_radd.c     */
/* d_rsub.c                                             */
{    5,  "\rSignaling NaN as operand\n" },
/* e_xofl                                               */
{    6,  "Overflow occurred\n" },
/* e_xufl                                               */
{    7,  "Underflow occurred\n" },
/* e_xine                                               */
{    8,  "Inexact\n" },
/* addbody.h,d_radd.c,d_rsub.c                          */
{    9,  "\rinfinity-infinity\n" },
/* mulbody.h,d_dot.c,d_padd.c,d_psub.c                  */
{   10,  "\r0*infinity\n" },
/* e_xall.c                                             */
{   11,  "Allocation failed : " },
/* e_xarg.c                                             */
{   12,  "Invalid argument to standard function.\n" },
/* d_dot.c,d_padd.c,d_psub.c,d_radd.c,d_rsub.c,d_sum.c  */
{   13,  "\rInfinity occurred in dotprecision operation.\n" },
/* d_dot.c,d_padd.c,d_psub.c,d_radd.c,d_rsub.c,d_sum.c  */
{   14,  "\rQuiet NaN occurred in dotprecision operation.\n" },
/* a_abs_.c,f_rint.c                                    */
{   15,  "Range of integer data type exceeded.\n" },
/* e_xios.c                                             */
{   16,  "Error in I/O operation : " },
/* f_rdln.c,f_rdi1.c,f_get_.c                           */
{   17,  "\rNo device assigned.\n" },
/* f_rdln.c,f_rdi1.c,f_get_.c                           */
{   18,  "\rDevice not opened for reading.\n" },
/* f_rdln.c,f_rdi1.c                                    */
{   19,  "\rDevice not a TEXT device.\n" },
/* f_rdln.c,f_rdi1.c,f_rint.c,f_rhex.c                  */
{   20,  "\rUnexpected End-Of-File.\n" },
/* f_rint.c                                             */
{   21,  "\rInvalid syntax of integer value.\n" },
/* a_mod_.c                                             */
{   22,  "Non-positive modulo value.\n" },
/* a_ixch.c,e_xset,s_slen                               */
{   23,  "Index out of range.\n" },
/* a_nilc.c                                             */
{   24,  "Unexpected NULL pointer.\n" },
/* e_xnor.c                                             */
{   25,  "\r\r------ Processing aborted ------\n" },
/* r_scpy.c, c_scpy.c, i_scpy.c, z_scpy.c               */
{   26,  "One-dimensional dynamic array expected.\n" },
/* r_scpy.c, c_scpy.c, i_scpy.c, z_scpy.c               */
{   27,  "Equal length of dynamic vectors expected.\n" },
/* s_subs.c                                             */
{   28,  "Substring destination array shorter than required.\n" },
/* e_xiob.c                                             */
{   29,  "Internal buffer too small : " },
/* f_assg.c                                             */
{   30,  "\rFilename too long\n" },
/* f_assg.c,f_rset.c,f_rstn.c                           */
{   31,  "\rUnable to open file for reading\n" },
/* f_assg.c,f_rwri.c,f_rwrn.c                           */
{   32,  "\rUnable to open file for writing\n" },
/* f_rset.c,f_rstn.c                                    */
{   33,  "\rStandard I/O must not be used for binary I/O.\n" },
/* f_put_.c                                             */
{   34,  "\rDevice not opened for writing.\n" },
/* f_put_.c                                             */
{   35,  "\rError writing data to file.\n" },
/* f_writ.c,f_read.c                                    */
{   36,  "\rDevice not a binary device.\n" },
/* f_assg.c                                             */
{   37,  "\rMissing command line argument.\n" },
/* f_rset.c                                             */
{   38,  "\rNo filename has previously been assigned.\n" },
/* b_outm.c                                             */
{   39,  "\rMultiprecision mantissa too long.\n" },
/* d_init.c                                             */
{   40,  "\rDotprecision variable not allocated.\n" },
/* e_actn.c                                             */
{   41,  "\rTrap handler not stacked.\n" },
/* y_asgn.c                                             */
{   42,  "\rDynamic array not allocated.\n" },
/* f_rstn.c                                             */
{   43,  "Undefined device specification.\n" },
/* f_wrc1.c                                             */
{   44,  "Invalid width of output field.\n" },
/* f_exst.c                                             */
{   45,  "\rInvalid filename.\n" },
/* d_vlcp.c                                             */
{   46,  "\rDotprecision variable not allocated.\n" },
/* r_comp.c                                             */
{   47,  "Mantissa out of range (1.0<=|mantissa|<2.0).\n" },
/* r_comp.c                                             */
{   48,  "Exponent too large (infinity returned).\n" },
/* r_comp.c                                             */
{   49,  "Mantissa bits lost on generating denormalized number.\n" },
/* r_comp.c                                             */
{   50,  "Exponent too small (zero returned).\n" },
/* f_rhex.c                                             */
{   51,  "\rInvalid read/write mode.\n" },
/* f_rhex.c                                             */
{   52,  "\rInvalid syntax of hexadecimal value.\n" },
/* f_rhex.c                                             */
{   53,  "\rUnexpected End-Of-Line.\n" },
/* s_init.c,s_genv.v                                    */
{   54,  "\rDynamic string not allocated.\n" },
/* f_rds1.c                                             */
{   55,  "\rReading a dynamic string.\n" },
/* r_aval.c,r_sval.c,r_read.c                           */
{   56,  "\rConverting string to real.\n" },
/* s_aimg.c,s_simg.c                                    */
{   57,  "\rConverting real to string.\n" },
/* r_conv.c,r_read.c                                    */
{   58,  "\rInvalid syntax of real value.\n" },
/* r_cnst.c                                             */
{   59,  "Inexact conversion of decimal constant.\n" },
/* r_rdr1.c                                             */
{   60,  "Inexact conversion of decimal input data.\n" },
/* s_genv.c                                             */
{   61,  "\rMissing variable name.\n" },
/* a_ival.c                                             */
{   62,  "\rEmpty string.\n" },
/* a_ival.c                                             */
{   63,  "\rNo digits in string.\n" },

/*------------------------------------------------------*/
/* These codes are explicitly generated by PASCAL-XSC.  */
/*------------------------------------------------------*/
{  400,  "Summation of vectors with different lengths.\n" },
/*                                                      */
{  401,  "Scalar product of vectors with different lengths.\n" },
/*                                                      */
{  402,  "Function call with vectors of different lengths.\n" },
/*                                                      */
{  403,  "Mismatching inner lengths in a matrix-vector product.\n" },
/*                                                      */
{  404,  "Summation of matrices with different row lengths.\n" },
/*                                                      */
{  405,  "Summation of matrices with different column lengths.\n" },
/*                                                      */
{  406,  "Function call with matrices of different row lengths.\n" },
/*                                                      */
{  407,  "Function call with matrices of different column lengths.\n" },
/*                                                      */
{  408,  "Mismatching inner lengths of arguments in a function call.\n" },
/*                                                      */
{  409,  "Mismatching inner lengths in a matrix-matrix product.\n" },

/*------------------------------------------------------*/
/* These codes must be even multiples of E_TRES=256     */
/* within the range                                     */
/*           (2*256=) 512<=msgid<=32256 (=126*256).     */
/*------------------------------------------------------*/

{  512,  "\r left operand : " }                   /* E_TEXT(1)    */
{ 1024,  "\rright operand : " }                   /* E_TEXT(2)    */
{ 1536,  "\r       result : " }                   /* E_TEXT(3)    */
{ 2048,  "\r        index : " }                   /* E_TEXT(4)    */
{ 2560,  "\r  lower bound : " }                   /* E_TEXT(5)    */
{ 3072,  "\r  upper bound : " }                   /* E_TEXT(6)    */
{ 3584,  "\r     argument : " }                   /* E_TEXT(7)    */
